/* Prompt.c generated by valac 0.40.7, the Vala compiler
 * generated from Prompt.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*- */
/*
    This file is part of Déjà Dup.
    For copyright information, see AUTHORS.

    Déjà Dup is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Déjà Dup is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Déjà Dup.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "deja.h"
#include "widgets.h"
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block6Data Block6Data;

struct _Block6Data {
	int _ref_count_;
	GtkApplication* app;
};



GtkWindow* prompt (GtkApplication* app);
void show_prompt_notification (GtkApplication* app);
GtkWindow* show_prompt_dialog (GtkApplication* app);
gchar* get_header (void);
gchar* get_body (void);
gchar* get_cancel_button (gboolean mnemonics);
gchar* get_ok_button (gboolean mnemonics);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void __lambda40_ (Block6Data* _data6_,
                  GtkDialog* dlg,
                  gint resp);
static void ___lambda40__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);


GtkWindow*
prompt (GtkApplication* app)
{
	GtkWindow* result = NULL;
	g_return_val_if_fail (app != NULL, NULL);
	deja_dup_update_prompt_time (FALSE);
	if (deja_dup_get_shell () == DEJA_DUP_SHELL_ENV_GNOME) {
		show_prompt_notification (app);
		result = NULL;
		return result;
	} else {
		GtkWindow* _tmp0_;
		_tmp0_ = show_prompt_dialog (app);
		result = _tmp0_;
		return result;
	}
}


gchar*
get_header (void)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	_tmp0_ = g_strdup (_ ("Keep your files safe by backing up regularly"));
	result = _tmp0_;
	return result;
}


gchar*
get_body (void)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	_tmp0_ = g_strdup (_ ("Important documents, data, and settings can be protected by storing th" \
"em in a backup. In the case of a disaster, you would be able to recove" \
"r them from that backup."));
	result = _tmp0_;
	return result;
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch4_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch4_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally4;
	__catch4_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally4:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


gchar*
get_cancel_button (gboolean mnemonics)
{
	gchar* result = NULL;
	gchar* rv = NULL;
	gchar* _tmp0_;
	_tmp0_ = g_strdup (_ ("_Don't Show Again"));
	rv = _tmp0_;
	if (!mnemonics) {
		const gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = rv;
		_tmp2_ = string_replace (_tmp1_, "_", "");
		_g_free0 (rv);
		rv = _tmp2_;
	}
	result = rv;
	return result;
}


gchar*
get_ok_button (gboolean mnemonics)
{
	gchar* result = NULL;
	gchar* rv = NULL;
	gchar* _tmp0_;
	_tmp0_ = g_strdup (_ ("_Open Backup Settings"));
	rv = _tmp0_;
	if (!mnemonics) {
		const gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = rv;
		_tmp2_ = string_replace (_tmp1_, "_", "");
		_g_free0 (rv);
		rv = _tmp2_;
	}
	result = rv;
	return result;
}


void
show_prompt_notification (GtkApplication* app)
{
	GNotification* note = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GNotification* _tmp2_;
	GNotification* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GThemedIcon* _tmp6_;
	GThemedIcon* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	g_return_if_fail (app != NULL);
	_tmp0_ = get_header ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_notification_new (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	note = _tmp3_;
	_tmp4_ = get_body ();
	_tmp5_ = _tmp4_;
	g_notification_set_body (note, _tmp5_);
	_g_free0 (_tmp5_);
	_tmp6_ = (GThemedIcon*) g_themed_icon_new ("org.gnome.DejaDup");
	_tmp7_ = _tmp6_;
	g_notification_set_icon (note, (GIcon*) _tmp7_);
	_g_object_unref0 (_tmp7_);
	g_notification_set_default_action (note, "app.prompt-ok");
	_tmp8_ = get_cancel_button (FALSE);
	_tmp9_ = _tmp8_;
	g_notification_add_button (note, _tmp9_, "app.prompt-cancel");
	_g_free0 (_tmp9_);
	_tmp10_ = get_ok_button (FALSE);
	_tmp11_ = _tmp10_;
	g_notification_add_button (note, _tmp11_, "app.prompt-ok");
	_g_free0 (_tmp11_);
	g_application_send_notification ((GApplication*) app, "prompt", note);
	_g_object_unref0 (note);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}


static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		_g_object_unref0 (_data6_->app);
		g_slice_free (Block6Data, _data6_);
	}
}


static void
__lambda40_ (Block6Data* _data6_,
             GtkDialog* dlg,
             gint resp)
{
	g_return_if_fail (dlg != NULL);
	if (resp == ((gint) GTK_RESPONSE_REJECT)) {
		g_action_group_activate_action ((GActionGroup*) _data6_->app, "prompt-cancel", NULL);
	} else {
		if (resp == ((gint) GTK_RESPONSE_ACCEPT)) {
			g_action_group_activate_action ((GActionGroup*) _data6_->app, "prompt-ok", NULL);
		}
	}
	deja_dup_destroy_widget ((GtkWidget*) dlg);
}


static void
___lambda40__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
	__lambda40_ (self, _sender, response_id);
}


GtkWindow*
show_prompt_dialog (GtkApplication* app)
{
	GtkWindow* result = NULL;
	Block6Data* _data6_;
	GtkApplication* _tmp0_;
	GtkMessageDialog* dlg = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GtkMessageDialog* _tmp3_;
	GtkMessageDialog* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GtkImage* img = NULL;
	GtkImage* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	g_return_val_if_fail (app != NULL, NULL);
	_data6_ = g_slice_new0 (Block6Data);
	_data6_->_ref_count_ = 1;
	_tmp0_ = _g_object_ref0 (app);
	_g_object_unref0 (_data6_->app);
	_data6_->app = _tmp0_;
	_tmp1_ = get_header ();
	_tmp2_ = _tmp1_;
	_tmp3_ = (GtkMessageDialog*) gtk_message_dialog_new (NULL, 0, GTK_MESSAGE_INFO, GTK_BUTTONS_NONE, "%s", _tmp2_);
	g_object_ref_sink (_tmp3_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	dlg = _tmp4_;
	_tmp5_ = get_body ();
	_tmp6_ = _tmp5_;
	gtk_message_dialog_format_secondary_text (dlg, "%s", _tmp6_);
	_g_free0 (_tmp6_);
	gtk_window_set_skip_taskbar_hint ((GtkWindow*) dlg, FALSE);
	gtk_window_set_title ((GtkWindow*) dlg, _ ("Backups"));
	_tmp7_ = (GtkImage*) gtk_image_new_from_icon_name ("org.gnome.DejaDup", (GtkIconSize) GTK_ICON_SIZE_DIALOG);
	g_object_ref_sink (_tmp7_);
	img = _tmp7_;
	g_object_set ((GtkMisc*) img, "yalign", 0.0f, NULL);
	gtk_widget_show ((GtkWidget*) img);
	gtk_message_dialog_set_image (dlg, (GtkWidget*) img);
	_tmp8_ = get_cancel_button (TRUE);
	_tmp9_ = _tmp8_;
	_tmp10_ = get_ok_button (TRUE);
	_tmp11_ = _tmp10_;
	gtk_dialog_add_buttons ((GtkDialog*) dlg, _tmp9_, GTK_RESPONSE_REJECT, _tmp11_, GTK_RESPONSE_ACCEPT, NULL);
	_g_free0 (_tmp11_);
	_g_free0 (_tmp9_);
	g_signal_connect_data ((GtkDialog*) dlg, "response", (GCallback) ___lambda40__gtk_dialog_response, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
	deja_dup_show_background_window_for_shell ((GtkWindow*) dlg);
	result = (GtkWindow*) dlg;
	_g_object_unref0 (img);
	block6_data_unref (_data6_);
	_data6_ = NULL;
	return result;
}



